=== debian/changelog ===
rocm-llvm (6.4.3+dfsg-1~exp3) experimental; urgency=medium

  * Re-upload with rocm-llvm_6.4.3+dfsg.orig.tar.xz

 -- Cordell Bloor <cgmb@debian.org>  Fri, 15 Aug 2025 04:04:26 -0600

rocm-llvm (6.4.3+dfsg-1~exp2) experimental; urgency=medium

  * Add d/p/add-hipvars-to-perl-include-path.patch to fix use of hipvars
    in hipcc and hipconfig.

 -- Cordell Bloor <cgmb@debian.org>  Fri, 15 Aug 2025 00:54:53 -0600

rocm-llvm (6.4.3+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3+dfsg
    * Based on LLVM 20
    * Update Files-Excluded
  * Replace libamd-comgr2 with libamd-comgr3
  * Switch to hand-written hipcc man pages
  * Update d/watch to Version 5
  * Refresh patches
  * Drop d/p/0001-add-wf64-target-constraints-to-kernels-using-w64-ins.patch
  * Drop patch numbers
  * Add d/p/upstream-llvm-compatibility.patch to enable compatibility
    with LLVM 20
  * Add d/p/cmake-4-compat.patch to enable compatibility with CMake 4.1
  * hipcc now depends on libamdhip64-dev, rather than merely recommending it.
    This is a return to the hipcc package behaviour from Trixie.
  * Add self to uploaders

 -- Cordell Bloor <cgmb@debian.org>  Thu, 14 Aug 2025 22:32:37 -0600
